<template>
    <div
        v-if="shop"
        class="table-responsive"
    >
        <table
            class="table-hover"
        >
            <thead class="table-header">
                <tr>
                    <th class="reminders-text">
                        Pop Up
                    </th>
                    <th>Impressions</th>
                    <th>Subscribers</th>
                    <th>CVR</th>
                    <th>Avg Channels per subscribers</th>
                    <th>Email subscribers</th>
                    <th>SMS subscribers</th>
                    <th>Push subscribers</th>
                    <th>Revenue</th>
                    <th>Active</th>
                    <th />
                </tr>
            </thead>
            <tbody class="table-body">
                <tr
                    v-for="(popup, index) in data.popups"
                    :key="index"
                    class="table-body-row"
                >
                    <th class="first-column">
                        {{ popup.name }}
                    </th>
                    <th> {{ popup.impressions }}</th>
                    <th>{{ popup.subscribers }}</th>
                    <th> {{ popup.cvr }}%</th>
                    <th> {{ popup.perChannel }}</th>
                    <th> {{ popup.emailSubscriber }}</th>
                    <th> {{ popup.smsSubscriber }}</th>
                    <th> {{ popup.pushSubscriber }}</th>
                    <th> {{ popup.revenue }}{{ getCurrencySign.symbol_native }}</th>
                    <th>
                        <ToggleButton
                            v-model="popup.status"
                            :font-size="12"
                            class="toggle-btn"
                            :height="24"
                            :labels="true"
                            color="rgb(45, 119, 245)"
                            @change="changeStatus(popup)"
                        />
                    </th>
                    <th

                        class="text-left"
                    >
                        <router-link
                            :to="'/growth-tools-edit/'+ popup.id"
                            class="btn light-blue-btn"
                        >
                            Edit
                        </router-link>
                        <button
                            class="red-button"
                            type="button"
                            @click="removePopup(popup.id)"
                        >
                            Delete
                        </button>
                    </th>
                </tr>
            </tbody>
        </table>
    </div>
</template>

<script>
import headers from '../../helpers/authHeader';
import link from '../../helpers/backLink';
import currencies from "../../data/currencies.json";
import shop from '../../mixins/shop.service';

export default {
    name: "GrowthTable",
    mixins: [link, headers, shop],
    props: ['data'],
    data() {
        return {
            shop: null,
            currencies: currencies
        }
    },
    computed: {
        getCurrencySign() {
            if (!this.currencies)
                return {
                    symbol: this.shop?.payment_currency
                };
            return this.currencies[this.shop.payment_currency];
        }
    },
    created() {
        this.loadShop()
    },
    methods: {
        async loadShop() {
            this.shop = await this.getShop()
        },
        removePopup(id) {
            axios.delete(`${this.getSegment()}/growth/${id}`,  this.getUserHeader()).then(response => {
                this.$emit('freshData')
            });
        },
        changeStatus(popup) {
            axios.put(`${this.getSegment()}/growth/` + popup.id + '/status/', {status: popup.status}, this.getUserHeader())
                .then(response => {
                    this.$notify({
                        type: 'success',
                        title: 'Status Changed'
                    });
                });
        },
    }
}
</script>

<style scoped>

.toggle-btn {
    margin-right: 0;
}

.first-column {
    text-align: left;
}

</style>
